﻿Public Class Form1

    Dim mainTable As New DataTable()
    Dim tempTable As New DataTable()            'Temporary Table to be operated
    Dim tempNumTable As New DataTable()         'Temporary Table to store 
    Dim tempRow1 As System.Data.DataRow, tempRow2 As System.Data.DataRow
    Dim resultString As String, subjectString As String
    Dim temp As Integer, sortingCount As Integer = 0

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        mainTable.Columns.Add("CustomerID", GetType(String))
        mainTable.Columns.Add("Name", GetType(String))
        mainTable.Columns.Add("Department", GetType(String))
        mainTable.Columns.Add("Designation", GetType(String))
        mainTable.Columns.Add("Country", GetType(String))

        mainTable.Rows.Add("13IND452APP56", "Mohit", "Apps", "Tester", "India")
        mainTable.Rows.Add("12USA534MAN45", "John", "Maintenance", "Electrician", "USA")
        mainTable.Rows.Add("13USA457ACC42", "Mark", "Accounts", "Accountant", "USA")
        mainTable.Rows.Add("11JPN426MAN75", "Koizumi", "Maintenance", "Guard", "Japan")
        mainTable.Rows.Add("14RUS782APP26", "Medvedev", "Apps", "Engineer", "Russia")
        mainTable.Rows.Add("13JPN459ACC56", "Atoyama", "Accounts", "Clerk", "Japan")
        mainTable.Rows.Add("11CHN716HRD72", "Yuanchao", "Human Resources", "Manager", "China")
        mainTable.Rows.Add("12IND791ACC76", "Sonu", "Accounts", "Accountant", "India")
        mainTable.Rows.Add("13RUS462HRD94", "Siluanov", "Human Resources", "Coordinator", "Russia")
        mainTable.Rows.Add("11USA426APP79", "Paul", "Apps", "Tester", "USA")
        mainTable.Rows.Add("14JPN424MAN82", "Yoshihiko", "Maintenance", "Gaurd", "Japan")
        mainTable.Rows.Add("14JPN452ACC34", "Yukio", "Accounts", "Clerk", "Japan")
        mainTable.Rows.Add("11RUS777HRD94", "Ulyukaev", "Human Resources", "Manager", "Russia")
        mainTable.Rows.Add("14IND722APP17", "Shubham", "Apps", "Engineer", "India")
        mainTable.Rows.Add("11CHN782MAN93", "Jinping", "Maintenance", "Electrician", "China")
        mainTable.Rows.Add("12RUS786HRD19", "Novak", "Human Resources", "Coordinator", "Russia")
        mainTable.Rows.Add("11CHN450ACC72", "Zhang", "Accounts", "Clerk", "China")

        tempTable = mainTable.Copy()                'Sample Data

        C1FlexGrid1.DataSource = tempTable
        C1FlexGrid1.Cols(1).AllowSorting = True
        C1FlexGrid1.Styles.Fixed.BackColor = Color.LightGreen
        C1FlexGrid1.Cols(1).StyleNew.BackColor = Color.LightBlue

    End Sub

    Private Sub C1FlexGrid1_AfterSort(sender As Object, e As C1.Win.C1FlexGrid.SortColEventArgs) Handles C1FlexGrid1.AfterSort
        If e.Col = 1 Then
            e.Cancel = True                         'For supressing default sorting behaviour
        End If
    End Sub

    Private Sub C1FlexGrid1_BeforeSort(sender As Object, e As C1.Win.C1FlexGrid.SortColEventArgs) Handles C1FlexGrid1.BeforeSort
        tempTable = mainTable.Copy()
        tempNumTable = New DataTable()
        tempNumTable.Columns.Add("NumberInCustomerID", GetType(Integer))

        If e.Col = 1 Then
            For row As Integer = 0 To tempTable.Rows.Count - 1
                subjectString = tempTable.Rows(row).ItemArray(0).ToString()
                resultString = System.Text.RegularExpressions.Regex.Replace(subjectString, "\D", "")            'For taking out numerical data
                tempNumTable.Rows.Add(Convert.ToInt32(resultString))
            Next

            If sortingCount Mod 2 = 0 Then                                                                        'For Ascending Sorting
                For i As Integer = 0 To tempNumTable.Rows.Count - 1
                    For j As Integer = 0 To tempNumTable.Rows.Count - 1 - i - 1
                        If Convert.ToInt32(tempNumTable.Rows(j).ItemArray(0)) > Convert.ToInt32(tempNumTable.Rows(j + 1).ItemArray(0)) Then
                            temp = Convert.ToInt32(tempNumTable.Rows(j + 1)(0))
                            tempNumTable.Rows(j + 1)(0) = tempNumTable.Rows(j)(0)
                            tempNumTable.Rows(j)(0) = temp

                            tempRow1 = tempTable.NewRow()                   'Temporary Rows used for swapping
                            tempRow2 = tempTable.NewRow()
                            tempRow1.ItemArray = tempTable.Rows(j).ItemArray
                            tempRow2.ItemArray = tempTable.Rows(j + 1).ItemArray
                            tempTable.Rows.RemoveAt(j)
                            tempTable.Rows.RemoveAt(j)
                            tempTable.Rows.InsertAt(tempRow2, j)
                            tempTable.Rows.InsertAt(tempRow1, j + 1)
                        End If
                    Next
                Next

            ElseIf sortingCount Mod 2 <> 0 Then               'For column 1 and Decending Sorting
                For i As Integer = 0 To tempNumTable.Rows.Count - 1
                    For j As Integer = 0 To tempNumTable.Rows.Count - 1 - i - 1
                        If Convert.ToInt32(tempNumTable.Rows(j).ItemArray(0)) < Convert.ToInt32(tempNumTable.Rows(j + 1).ItemArray(0)) Then
                            temp = Convert.ToInt32(tempNumTable.Rows(j + 1)(0))
                            tempNumTable.Rows(j + 1)(0) = tempNumTable.Rows(j)(0)
                            tempNumTable.Rows(j)(0) = temp

                            tempRow1 = tempTable.NewRow()
                            tempRow2 = tempTable.NewRow()
                            tempRow1.ItemArray = tempTable.Rows(j).ItemArray
                            tempRow2.ItemArray = tempTable.Rows(j + 1).ItemArray
                            tempTable.Rows.RemoveAt(j)
                            tempTable.Rows.RemoveAt(j)
                            tempTable.Rows.InsertAt(tempRow2, j)
                            tempTable.Rows.InsertAt(tempRow1, j + 1)
                        End If
                    Next
                Next
            End If
            sortingCount += 1
            C1FlexGrid1.DataSource = tempTable                              'For supressing default sorting behaviour
            e.Cancel = True
        End If
        C1FlexGrid1.Cols(1).StyleNew.BackColor = Color.LightBlue
    End Sub
End Class
